// generated with AvrWiz (by g@greschenz.de)
// -----------------------------------------
// cpu:     ATmega16
// speed:   11.0592 mhz (max: 16 mhz)
// voltage: 5 V
// ram:     1024 bytes (0x0060-0x045f)
// rom:     8192 bytes (0x0000-0x1fff)
// eeprom:  512 bytes (0x0000-0x01ff)
// -----------------------------------------

#include <avr/io.h>
#include <avr/interrupt.h>

#if !defined (__AVR_ATmega16__)
#error __AVR_ATmega16__ not defined !
#endif

#if !defined (F_CPU)
#define F_CPU 11059200
#endif

#define RAMSTART 0x0060
#define RAMSIZE (RAMEND-RAMSTART)

#define sleep()

// --------------
// --- USART0 ---
// --------------

void USART0_Transmit(unsigned char data)
{
	while (!(UCSRA & (1<<UDRE))) sleep();
	UDR = data;
}
void USART0_TransmitString(char *data)
{
	while (*data) USART0_Transmit(*data++);
}
void USART0_Init(void)
{
	// USART0 settings: 57600 baud 8-n-1
	UBRRH = 0;
	UBRRL = 11;
	UCSRB = (1<<TXEN);
	UCSRC = (1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0);
}

// --------------
// --- main() ---
// --------------

int main()
{
	USART0_Init();
	sei(); // enable interrupts

// sample code for USART0

for (;;)
{
	USART0_TransmitString("Hello word!\r\n");
}
	for (;;) sleep();
	return 0;
}
